package org.jeecg.modules.resrun.sdk.service.pojo;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.IOException;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import org.apache.commons.io.FileUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.pdfbox.Loader;
import org.apache.pdfbox.pdmodel.PDDocument;
import org.apache.pdfbox.text.PDFTextStripper;
import org.apache.pdfbox.text.TextPosition;

public class SelectKeywords extends PDFTextStripper {

   private static ThreadLocal keyWorkPair = new ThreadLocal();
   private Log logger = LogFactory.getLog(SelectKeywords.class);
   PDDocument document = null;
   private StringBuilder tWord = new StringBuilder();
   private boolean is1stChar = true;
   private boolean lineMatch;
   private int pageNo = 0;
   private double lastYVal;
   private TextPosition itext;


   public SelectKeywords() throws IOException {
      super.setSortByPosition(true);
   }

   public static void main(String[] args) throws Exception {
      File file = new File("E:\\work\\tem\\pdfbox\\123456.pdf");
      byte[] pdf = FileUtils.readFileToByteArray(file);
      (new SelectKeywords()).selectAllKeyword(pdf, "123456");
   }

   public List selectAllKeyword(byte[] pdfFile, String KEY_WORD) {
      keyWorkPair.set(new SelectKeywords.KeyWorkPair(KEY_WORD.split(",")));
      ByteArrayInputStream in = null;

      try {
         in = new ByteArrayInputStream(pdfFile);
         this.document = Loader.loadPDF(pdfFile);
         this.getText(this.document);
         List e = this.getAllResult();
         List var5 = e;
         return var5;
      } catch (Exception var15) {
         var15.printStackTrace();
      } finally {
         try {
            if(in != null) {
               in.close();
            }

            if(this.document != null) {
               this.document.close();
            }
         } catch (IOException var14) {
            ;
         }

      }

      return null;
   }

   private float getDocHeight(int index) {
      if(index > this.document.getPages().getCount()) {
         throw new RuntimeException("页码不能大于PDF总页码");
      } else {
         return this.document.getPage(index - 1).getRotation() != 90 && this.document.getPage(index - 1).getRotation() != 270?this.document.getPage(index - 1).getCropBox().getHeight():this.document.getPage(index - 1).getCropBox().getWidth();
      }
   }

   private List getAllResult() {
      SelectKeywords.KeyWorkPair pair = (SelectKeywords.KeyWorkPair)keyWorkPair.get();
      if(pair != null && pair.getResu() != null) {
         keyWorkPair.set((Object)null);
         return pair.getAllResu();
      } else {
         keyWorkPair.set((Object)null);
         return null;
      }
   }

   public float[] selectKeyword(byte[] pdfFile, String KEY_WORD) {
      keyWorkPair.set(new SelectKeywords.KeyWorkPair(KEY_WORD.split(",")));
      ByteArrayInputStream in = null;
      PDDocument document = null;

      try {
         in = new ByteArrayInputStream(pdfFile);
         document = Loader.loadPDF(pdfFile);
         this.getText(document);
         float[] e = this.getResult();
         float[] var6 = e;
         return var6;
      } catch (Exception var16) {
         var16.printStackTrace();
      } finally {
         try {
            if(in != null) {
               in.close();
            }

            if(document != null) {
               document.close();
            }
         } catch (IOException var15) {
            ;
         }

      }

      return null;
   }

   private float[] getResult() {
      SelectKeywords.KeyWorkPair pair = (SelectKeywords.KeyWorkPair)keyWorkPair.get();
      if(pair != null && pair.getResu() != null) {
         keyWorkPair.set((Object)null);
         return pair.getResu();
      } else {
         keyWorkPair.set((Object)null);
         return null;
      }
   }

   protected void writeString(String string, List textPositions) throws IOException {
      Iterator var3 = textPositions.iterator();

      while(var3.hasNext()) {
         TextPosition text = (TextPosition)var3.next();
         String tChar = text.toString();
         char c = tChar.charAt(0);
         String REGEX = "[,.\\[\\](:;!?)/]";
         this.lineMatch = this.matchCharLine(text);
         if(!tChar.matches(REGEX) && !Character.isWhitespace(c)) {
            if(!this.is1stChar && this.lineMatch) {
               this.appendChar(tChar);
            } else if(this.is1stChar) {
               this.setWordCoord(text, tChar);
            }
         } else {
            this.endWord();
         }
      }

      this.endWord();
   }

   protected void appendChar(String tChar) {
      this.tWord.append(tChar);
      this.is1stChar = false;
   }

   protected void setWordCoord(TextPosition text, String tChar) {
      this.itext = text;
      this.tWord.append("(").append(this.pageNo).append(")[").append(this.roundVal(Float.valueOf(text.getXDirAdj()))).append(" : ").append(this.roundVal(Float.valueOf(text.getYDirAdj()))).append("] ").append(tChar);
      this.is1stChar = false;
   }

   protected boolean matchCharLine(TextPosition text) {
      Double yVal = this.roundVal(Float.valueOf(text.getYDirAdj()));
      if(yVal.doubleValue() == this.lastYVal) {
         return true;
      } else {
         this.lastYVal = yVal.doubleValue();
         this.endWord();
         return false;
      }
   }

   protected Double roundVal(Float yVal) {
      DecimalFormat rounded = new DecimalFormat("0.0\'0\'");
      Double yValDub = new Double(rounded.format(yVal));
      return yValDub;
   }

   protected void endWord() {
      String newWord = this.tWord.toString();
      SelectKeywords.KeyWorkPair pair = (SelectKeywords.KeyWorkPair)keyWorkPair.get();

      try {
         String[] e = pair.getSeekA();
         float[] resu = new float[3];
         String sWord = newWord.substring(newWord.lastIndexOf(32) + 1);
         if(!"".equals(sWord) && sWord.contains(e[0])) {
            resu[2] = (float)this.getCurrentPageNo();
            resu[0] = (float)(this.roundVal(Float.valueOf(this.itext.getXDirAdj())).doubleValue() + 0.0D);
            resu[1] = this.getDocHeight(this.getCurrentPageNo()) - (float)(this.roundVal(Float.valueOf(this.itext.getYDirAdj())).doubleValue() + 0.0D);
            this.logger.info("PDF关键字信息：[页数:" + resu[2] + "][X:" + resu[0] + "][Y:" + resu[1] + "]");
            pair.setResu(resu);
            pair.addResuList(resu);
            keyWorkPair.set(pair);
         }
      } catch (Exception var6) {
         var6.printStackTrace();
         keyWorkPair.set((Object)null);
         throw new RuntimeException();
      }

      this.tWord.delete(0, this.tWord.length());
      this.is1stChar = true;
   }


   class KeyWorkPair {

      private String[] seekA;
      private float[] resu;
      private List resuAll = new ArrayList();


      public KeyWorkPair(String[] seekA) {
         this.seekA = seekA;
      }

      public KeyWorkPair(String[] seekA, float[] resu) {
         this.seekA = seekA;
         this.resu = resu;
      }

      public KeyWorkPair() {
      }

      public String[] getSeekA() {
         return this.seekA;
      }

      public void setSeekA(String[] seekA) {
         this.seekA = seekA;
      }

      public float[] getResu() {
         return this.resu;
      }

      public void setResu(float[] resu) {
         this.resu = resu;
      }

      public void addResuList(float[] resu) {
         this.resuAll.add(resu);
      }

      public List getAllResu() {
         return this.resuAll;
      }
   }
}
